<template>
	<BaseLayout page-title="Academy" default-back-link="/">
		<SearchBar @filterSearch="filterSearch" />
		<Segments @filterSegment="filterSegment" />
		<ThemesList :themes="cThemes" />
		<CoursesList :courses="cCourses" />	
	</BaseLayout>
</template>

<script>
import axios from 'axios';
import ThemesList from './a-ThemesList.vue';
import CoursesList from './a-CoursesList.vue';
import Segments from './a-FilterSegments.vue';
import SearchBar from './a-SearchBar.vue';

export default {
	components: {
		ThemesList,
		CoursesList,
		Segments,
		SearchBar,
	},
	data: () => ({
		themes: [],
		courses: [],
		segment: '',
		searchString: '',
	}),
	computed: {
		cThemes() {		
			return this.filterData(
				this.themes, 
				this.segment, 
				this.searchString
			);
		},
		cCourses() {
			return this.filterData(
				this.courses, 
				this.segment, 
				this.searchString
			);
		}
	},
	methods: {
		filterSegment(val) {
			this.segment = val
		},
		filterSearch(val) {
			this.searchString = val
		},
		filterData(data, segment, searchString) {
			searchString = (searchString != null & searchString != undefined) ? searchString : '';
			segment = (segment != null && segment != undefined) ? segment : '';			
			data = data ? data : [];
			return data.filter(item => {
				let name = item.name.toLowerCase();
				let tags = item.tags_string ? item.tags_string.toLowerCase() : '';
				if(tags.includes(segment.toLowerCase()) || name.includes(segment.toLowerCase())) {
					if(tags.includes(searchString.toLowerCase()) || name.includes(searchString.toLowerCase())) return true;
					else return false;
				}
				return false;
			})
		},
	},
	mounted() {
		axios.get('https://academy.wezeo.dev/cms/api/v1/themes').then(res => {
			this.themes = res.data.data
			console.log('themes: ', this.themes)
		}, err => console.log(err))

		axios.get('https://open-academy.sk/cms/api/courses?results_per_page=1000').then(res => {
			this.courses = res.data.data
			console.log('courses: ', this.courses)
		}, err => console.log(err))
	}
}
</script>